Index: trunk/src/comctl32/rsrc.rc
===================================================================
--- trunk/src/comctl32/rsrc.rc	(revision 500)
+++ trunk/src/comctl32/rsrc.rc	(revision 501)
@@ -1,2 +1,3 @@
+/* $Id: rsrc.rc,v 1.4 1999-08-15 19:12:49 cbratschi Exp $ */
 #ifndef OS2_INCLUDED
    #include <os2.h>
@@ -32,5 +33,5 @@
         PUSHBUTTON      "Move ~Down", IDC_MOVEDN_BTN, 308, 20, 44, 14
         LTEXT           "Available buttons:", -1, 4, 110, 84, 10
-        LISTBOX         IDC_AVAILBTN_LBOX, 4, 8, 120, 100, LS_OWNERDRAW | 
+        LISTBOX         IDC_AVAILBTN_LBOX, 4, 8, 120, 100, LS_OWNERDRAW |
                         LS_NOADJUSTPOS | LS_HORZSCROLL
         PUSHBUTTON      "~Add ->", DID_OK, 131, 69, 44, 14
@@ -52,7 +53,54 @@
         PUSHBUTTON      "~Apply", IDC_APPLY_BUTTON, 181, 7, 50, 14
         PUSHBUTTON      "~Help", 9, 235, 7, 50, 14
-        CONTROL         "Tab", IDC_TABCONTROL, 7, 27, 278, 125, 
+        CONTROL         "Tab", IDC_TABCONTROL, 7, 27, 278, 125,
                         "SysTabControl32", WS_VISIBLE | WS_CLIPSIBLINGS
     END
 END
 
+/* Toolbar imagelist bitmaps */
+#define IDB_STD_SMALL       120
+#define IDB_STD_LARGE       121
+#define IDB_VIEW_SMALL      124
+#define IDB_VIEW_LARGE      125
+#define IDB_HIST_SMALL      130
+#define IDB_HIST_LARGE      131
+
+BITMAP IDB_STD_SMALL   "120.BMP"
+BITMAP IDB_STD_LARGE   "121.BMP"
+BITMAP IDB_VIEW_SMALL  "124.BMP"
+BITMAP IDB_VIEW_LARGE  "125.BMP"
+BITMAP IDB_HIST_SMALL  "130.BMP"
+BITMAP IDB_HIST_LARGE  "131.BMP"
+
+/* Month calendar month menu popup */
+#define IDD_MCMONTHMENU     300
+
+#define IDM_JAN                         301
+#define IDM_FEB                         302
+#define IDM_MAR                         303
+#define IDM_APR                         304
+#define IDM_MAY                         305
+#define IDM_JUN                         306
+#define IDM_JUL                         307
+#define IDM_AUG                         308
+#define IDM_SEP                         309
+#define IDM_OCT                         310
+#define IDM_NOV                         311
+#define IDM_DEC                         312
+
+MENU IDD_MCMONTHMENU LOADONCALL DISCARDABLE
+{
+  MENUITEM "&January", IDM_JAN
+  MENUITEM "&February", IDM_FEB
+  MENUITEM "&March", IDM_MAR
+  MENUITEM "&April", IDM_APR
+  MENUITEM "&May", IDM_MAY
+  MENUITEM "J&une", IDM_JUN
+  MENUITEM "Ju&ly", IDM_JUL
+  MENUITEM "Au&gust", IDM_AUG
+  MENUITEM "&September", IDM_SEP
+  MENUITEM "&October", IDM_OCT
+  MENUITEM "&November", IDM_NOV
+  MENUITEM "&December", IDM_DEC
+}
+
Index: trunk/src/comctl32/toolbar.c
===================================================================
--- trunk/src/comctl32/toolbar.c	(revision 500)
+++ trunk/src/comctl32/toolbar.c	(revision 501)
@@ -1,3 +1,3 @@
-/* $Id: toolbar.c,v 1.12 1999-08-14 16:13:13 cbratschi Exp $ */
+/* $Id: toolbar.c,v 1.13 1999-08-15 19:12:50 cbratschi Exp $ */
 /*
  * Toolbar control
@@ -30,4 +30,5 @@
   - IMAGELIST_Draw draws a line too at the bottom of the bitmap (toolbar.exe)
     imagelist uses default size values instead of real bitmap values
+  - LoadBitmapA -> use NativeLoadBitmap, is OS/2 bitmap resource
 */
 
@@ -135,5 +136,5 @@
 
     if (!himl)
-	return;
+        return;
 
     /* create new dc's */
@@ -1659,66 +1660,66 @@
     else if (lpAddBmp->hInst == HINST_COMMCTRL)
     {
-	/* Add system bitmaps */
-	switch (lpAddBmp->nID)
+        /* Add system bitmaps */
+        switch (lpAddBmp->nID)
       {
-	    case IDB_STD_SMALL_COLOR:
-		hbmLoad = LoadBitmapA (COMCTL32_hModule,
-				       MAKEINTRESOURCEA(IDB_STD_SMALL));
-		nIndex = ImageList_AddMasked (infoPtr->himlDef,
-					      hbmLoad, CLR_DEFAULT);
-		DeleteObject (hbmLoad);
-		break;
-
-	    case IDB_STD_LARGE_COLOR:
-		hbmLoad = LoadBitmapA (COMCTL32_hModule,
-				       MAKEINTRESOURCEA(IDB_STD_LARGE));
-		nIndex = ImageList_AddMasked (infoPtr->himlDef,
-					      hbmLoad, CLR_DEFAULT);
-		DeleteObject (hbmLoad);
-		break;
-
-	    case IDB_VIEW_SMALL_COLOR:
-		hbmLoad = LoadBitmapA (COMCTL32_hModule,
-				       MAKEINTRESOURCEA(IDB_VIEW_SMALL));
-		nIndex = ImageList_AddMasked (infoPtr->himlDef,
-					      hbmLoad, CLR_DEFAULT);
-		DeleteObject (hbmLoad);
-		break;
-
-	    case IDB_VIEW_LARGE_COLOR:
-		hbmLoad = LoadBitmapA (COMCTL32_hModule,
-				       MAKEINTRESOURCEA(IDB_VIEW_LARGE));
-		nIndex = ImageList_AddMasked (infoPtr->himlDef,
-					      hbmLoad, CLR_DEFAULT);
-		DeleteObject (hbmLoad);
-		break;
-
-	    case IDB_HIST_SMALL_COLOR:
-		hbmLoad = LoadBitmapA (COMCTL32_hModule,
-				       MAKEINTRESOURCEA(IDB_HIST_SMALL));
-		nIndex = ImageList_AddMasked (infoPtr->himlDef,
-					      hbmLoad, CLR_DEFAULT);
-		DeleteObject (hbmLoad);
-		break;
-
-	    case IDB_HIST_LARGE_COLOR:
-		hbmLoad = LoadBitmapA (COMCTL32_hModule,
-				       MAKEINTRESOURCEA(IDB_HIST_LARGE));
-		nIndex = ImageList_AddMasked (infoPtr->himlDef,
-					      hbmLoad, CLR_DEFAULT);
-		DeleteObject (hbmLoad);
-		break;
-
-	    default:
-	nIndex = ImageList_GetImageCount (infoPtr->himlDef);
-		//ERR ("invalid imagelist!\n");
-		break;
-	}
+            case IDB_STD_SMALL_COLOR:
+                hbmLoad = LoadBitmapA (COMCTL32_hModule,
+                                       MAKEINTRESOURCEA(IDB_STD_SMALL));
+                nIndex = ImageList_AddMasked (infoPtr->himlDef,
+                                              hbmLoad, CLR_DEFAULT);
+                DeleteObject (hbmLoad);
+                break;
+
+            case IDB_STD_LARGE_COLOR:
+                hbmLoad = LoadBitmapA (COMCTL32_hModule,
+                                       MAKEINTRESOURCEA(IDB_STD_LARGE));
+                nIndex = ImageList_AddMasked (infoPtr->himlDef,
+                                              hbmLoad, CLR_DEFAULT);
+                DeleteObject (hbmLoad);
+                break;
+
+            case IDB_VIEW_SMALL_COLOR:
+                hbmLoad = LoadBitmapA (COMCTL32_hModule,
+                                       MAKEINTRESOURCEA(IDB_VIEW_SMALL));
+                nIndex = ImageList_AddMasked (infoPtr->himlDef,
+                                              hbmLoad, CLR_DEFAULT);
+                DeleteObject (hbmLoad);
+                break;
+
+            case IDB_VIEW_LARGE_COLOR:
+                hbmLoad = LoadBitmapA (COMCTL32_hModule,
+                                       MAKEINTRESOURCEA(IDB_VIEW_LARGE));
+                nIndex = ImageList_AddMasked (infoPtr->himlDef,
+                                              hbmLoad, CLR_DEFAULT);
+                DeleteObject (hbmLoad);
+                break;
+
+            case IDB_HIST_SMALL_COLOR:
+                hbmLoad = LoadBitmapA (COMCTL32_hModule,
+                                       MAKEINTRESOURCEA(IDB_HIST_SMALL));
+                nIndex = ImageList_AddMasked (infoPtr->himlDef,
+                                              hbmLoad, CLR_DEFAULT);
+                DeleteObject (hbmLoad);
+                break;
+
+            case IDB_HIST_LARGE_COLOR:
+                hbmLoad = LoadBitmapA (COMCTL32_hModule,
+                                       MAKEINTRESOURCEA(IDB_HIST_LARGE));
+                nIndex = ImageList_AddMasked (infoPtr->himlDef,
+                                              hbmLoad, CLR_DEFAULT);
+                DeleteObject (hbmLoad);
+                break;
+
+            default:
+        nIndex = ImageList_GetImageCount (infoPtr->himlDef);
+                //ERR ("invalid imagelist!\n");
+                break;
+        }
     }
     else
     {
-	hbmLoad = LoadBitmapA (lpAddBmp->hInst, (LPSTR)lpAddBmp->nID);
-	nIndex = ImageList_AddMasked (infoPtr->himlDef, hbmLoad, CLR_DEFAULT);
-	DeleteObject (hbmLoad);
+        hbmLoad = LoadBitmapA (lpAddBmp->hInst, (LPSTR)lpAddBmp->nID);
+        nIndex = ImageList_AddMasked (infoPtr->himlDef, hbmLoad, CLR_DEFAULT);
+        DeleteObject (hbmLoad);
     }
 